// aktpruef.js

// Funktionen zum Aufbereiten des aktuellen Prfungsbogens bzw.
// der zu prfenden Fragen.
// Aufruf aus genpruef.js im Hauptverzeichnis des Trainers

// 1.) akt_uebung_initialisieren 
// 2.) je nach Bedarf einmal oder mehrmals die Funktionen
//     akt_uebung_aus_intervall_erweitern oder akt_uebung_um_pruefbogen_erweitern
//     aufrufen, um den gesamten Prfungsumfang zusammenzustellen.
//


function akt_uebung_initialisieren()
{
   // Initialisierung vor dem Zusammenstellen eines neuen bungsbogens
   uebung_anz_fragen   = 0; // Noch keine Fragen ermittelt
   uebung_fragen_offen = 0; 
}

function akt_uebung_aus_intervall_erweitern(intervall_nr, pruef_anzahl)
{
   // Aus dem gegebenen Intervall von Fragen wird die gegebene Anzahl zufllig
   // ermittelt und in das Array uebung_frage_nr eingetragen
   var i;
   var n;
   
   // Frageintervall (also gltige Fragenummern) ermitteln
   ueb_von = parent.NaviFrame.UEB_NR_VON[intervall_nr];
   ueb_bis = parent.NaviFrame.UEB_NR_BIS[intervall_nr];
   
   var frage_array = new Array();
   if (parent.NaviFrame.UEB_PRUEF_FRAGEN_ONLY == 1)
   {
      // Erzeugen Frage-Array nur mit Nummern, die auch in Prfungsbgen
      // vorkommen.
      n = 0;
      for (i = ueb_von; i <= ueb_bis; i++)
      {
         if (parent.NaviFrame.UEB_PRUEF_FRAGEN.indexOf(i) >= 0)
         {
            frage_array[n++] = i;
         }
      }
      
   } else {
      // Einfach alle Indizes in den Frage-Array kopieren
      for (i = 0; i < ueb_bis - ueb_von + 1; i++)
      {
         frage_array[i] = ueb_von + i;
      }
   }

   // Gewnschte Anzahl Fragen auswhlen
   frage_array = auswahl_fragen(frage_array, pruef_anzahl)
   
   // Jetzt wird das bestehende Uebungs-Array um neue Fragen erweitert
   for (i = 0; i < pruef_anzahl; i++)
   {
      uebung_anz_fragen++;
      uebung_frage_nr[uebung_anz_fragen] = frage_array[i];
   }
}    

function akt_uebung_um_pruefbogen_erweitern(bogen_nr)
{
    // Die aktuelle bung wird um die Fragen des angegebenen Prfungsbogen erweitert,
    // die in zuflliger Reihenfolge bertragen werden.
    frage_array = new Array();

    // bernehmen der Fragenummern aus dem Prfungsbogen
    anz_fragen = parent.NaviFrame.UEB_PRUEF_BOGEN[bogen_nr].length - 1;
    for (i = 0; i < anz_fragen; i++)
    {
       frage_array[i] = parent.NaviFrame.UEB_PRUEF_BOGEN[bogen_nr][i + 1];
    }
    
    // Im Endeffekt werden alle Fragen ausgewhlt...
    fragen_array = auswahl_fragen(frage_array, anz_fragen); 
    
    // Fragen wie im Frage-Array defineirt bernehmen....
    for (i = 0; i < anz_fragen; i++)
    {
       uebung_anz_fragen++;
       frage = frage_array[i];
       uebung_frage_nr[uebung_anz_fragen] = frage;   
    }
}

function auswahl_fragen(frage_array, anzahl_auswahl)
{
    // Eingabe ist ein Array mit Fragenummern
    // Ausgabe ist ein (verkrztes) Array mit ausgewhlten Fragen,
    // das wahlweise sortiert bergeben wird.
    // Bsp.: auswahl_indizes((18,19,29,31,45),3,0) = (31,45,18)

    // Zufllig Elemente auswhlen und an den Anfang kopieren
    // (dabei geht die Reihenfolge der Elemente untereinander 
    // verloren)
    for (i = 0; i < anzahl_auswahl; i++)
    {
       ix_zufall = i + Math.floor(Math.random() * (frage_array.length - i));
       h = frage_array[i];
       frage_array[i] = frage_array[ix_zufall];
       frage_array[ix_zufall] = h;
    }
    
    // Die nicht bentgten Array-Elemente lschen
    while (frage_array.length > anzahl_auswahl)
    {
       frage_array.pop();
    }
    
    // Auf Wunsch wird das Ergebnis-Array auch noch sortiert...
    if (!parent.NaviFrame.UEB_FRAGEN_MISCHEN)
    {
       frage_array.sort();
    }
    
    // Temp-Array als Ergebnis bergeben
    return frage_array;
}    
    
    
       
// End of File....